#define _ATL_PATH_USE_CSTRING

// wb_̒`Ȃ
#define Direct3DCreate9 Direct3DCreate9_hoge_fuga

#include <windows.h>
#include <shlwapi.h>
#include <d3d9.h>

#undef Direct3DCreate9

#pragma pack(4)

struct SWRFONT_DESC
{
	char FaceName[0x100];
	BYTE res_1CC;  /* color1 */
	BYTE res_1CB;
	BYTE res_1CA;
	BYTE res_1C9;  /* color2 */
	BYTE res_1C8;
	BYTE res_1C7;
	DWORD res_1C4; /* height */
	DWORD res_1C0; /* weight */
	BYTE res_1BC;  /* italic */
	BYTE res_1BB;
	BYTE res_1BA;
	DWORD res_1B8;
	DWORD res_1B4;
	DWORD res_1B0;
	DWORD res_1AC;
	DWORD res_1A8;
};

struct SWRSTR
{
	union {
		char  str[16];
		char* pstr;
	};
	size_t length;
};

struct SWRVERTEX
{
	float x, y, z;
	float rhw;
	D3DCOLOR color;
	float u, v;
};

#define FVF_SWRVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)

struct DNameUnit
{
	SWRFONT_DESC fontDesc;
	POINT position;
	bool backVisible;
};

template<typename TDest, typename TSrc>
__forceinline 	
TDest dangerous_cast(TSrc src) {
	union {
		TDest dst;
		TSrc  src;
	} c;
	c.src = src;
	return c.dst;
}

class C {};
#define Ccall(p,f,r,T) (((C*)p)->*dangerous_cast<r##(C::*)##T>(f))

typedef void (__fastcall *fastfunc)(void *p);
typedef int  (__fastcall *fastfuncr)(void *p);
typedef bool (__fastcall *fastfuncb)(void *p);

// tHgtB[h
#define font_ctor(p) \
	Ccall(p,0x410E80,void,())()
#define font_dtor(p) \
	Ccall(p,0x410F10,void,())()
#define font_setIndirect(p, pdesc) \
	Ccall(p,0x410FF0,void,(void*))(pdesc)
// eNX`}l[W
#define textureMgr_createTextTexture(p, ret, str, pdesc ,width ,height) \
	Ccall(p,0x405000,int*,(int*, LPCSTR, void*, int, int))(ret, str, pdesc, width, height)
#define textureMgr_loadTexture(p, ret, path, unk1, unk2) \
	Ccall(p,0x404F90,int*,(int*, LPCSTR, void*, void*))(ret, path, unk1, unk2)
#define textureMgr_remove(p, id) \
	Ccall(p,0x405070,void*,(int))(id)
#define textureMgr_get(p, id) \
	Ccall(p,0x402710,IDirect3DTexture9**,(int))(id)
// _
#define CRenderer_Begin(p) ((fastfuncr)0x401000)(p)
#define CRenderer_End(p) ((fastfunc)0x401040)(p)
// ogϐ
#define CBattleWatch_Create(p) ((fastfunc)s_origCBattleWatch_OnCreate)(p)
#define CBattleWatch_Render(p) ((fastfuncb)s_origCBattleWatch_OnRender)(p)
#define CBattleWatch_Destruct(p, dyn) \
	Ccall(p,s_origCBattleWatch_OnDestruct,void*,(int))(dyn)

// CHandleManager<IDirect3DTexture *>
#define g_texMgr ((void *)0x6DDCD0)
// IDirect3DDevice9
#define g_pd3dDev (*((IDirect3DDevice9**)0x6DE0D8))

#define g_renderer ((void *)0x6D4DA8)

#define g_pnetObject (*(char**)0x006D72DC)
#define g_pprofP1    (g_pnetObject + 0x04)
#define g_pprofP2    (g_pnetObject + 0x24)

static DWORD s_origCBattleWatch_OnCreate;
static DWORD s_origCBattleWatch_OnDestruct;
static DWORD s_origCBattleWatch_OnRender;
static DWORD s_origCBattleWatch_Size;

static DNameUnit s_p1Unit;
static DNameUnit s_p2Unit;

extern "C"
int _fltused = 1;

void DrawSprite(IDirect3DTexture9 *tex, float x, float y, float cx, float cy)
{
	const SWRVERTEX vertices[] = {
		{ x,      y,      0.0f, 1.0f, 0xffffffff, 0.0f, 0.0f },
		{ x + cx, y,      0.0f, 1.0f, 0xffffffff, 1.0f, 0.0f },
		{ x + cx, y + cy, 0.0f, 1.0f, 0xffffffff, 1.0f, 1.0f },
		{ x,      y + cy, 0.0f, 1.0f, 0xffffffff, 0.0f, 1.0f },
	};

	g_pd3dDev->SetTexture(0, tex);
	g_pd3dDev->SetFVF(FVF_SWRVERTEX);
	g_pd3dDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, vertices, sizeof(SWRVERTEX));
	g_pd3dDev->SetTexture(0, NULL);
}

void DrawUnit(const DNameUnit &unit, int bkTexID, int texID)
{
	if(unit.backVisible) {
		IDirect3DTexture9 **ppBkTex = textureMgr_get(g_texMgr, bkTexID);
		if(ppBkTex != NULL && *ppBkTex != NULL)
			DrawSprite(*ppBkTex, unit.position.x, unit.position.y, 216.0f, 32.0f);
	}
	IDirect3DTexture9 **ppTex = textureMgr_get(g_texMgr, texID);
	if(ppTex != NULL && *ppTex != NULL)
		DrawSprite(*ppTex,
			unit.position.x + 90.0f,
			unit.position.y + (25 - unit.fontDesc.res_1C4),
			1024.0f, unit.fontDesc.res_1C4 + 18);
}

void * __fastcall CBattleWatch_OnCreate(void *This)
{
	// super
	CBattleWatch_Create(This);
	
	int &m_p1TexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x00);
	int &m_p2TexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x04);
	int &m_p1BkTexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x08);
	int &m_p2BkTexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x0c);

	// VeNX`
	char font[0x1A4]; // Ƃ 0x1A4

	font_ctor(font);
	font_setIndirect(font, &s_p1Unit.fontDesc);
	textureMgr_createTextTexture(g_texMgr, &m_p1TexID, g_pprofP1, font, 0x400, s_p1Unit.fontDesc.res_1C4 + 18);
	font_dtor(font);

	font_ctor(font);
	font_setIndirect(font, &s_p2Unit.fontDesc);
	textureMgr_createTextTexture(g_texMgr, &m_p2TexID, g_pprofP2, font, 0x400, s_p2Unit.fontDesc.res_1C4 + 18);
	font_dtor(font);

	textureMgr_loadTexture(g_texMgr, &m_p1BkTexID,
		"data/scene/select/character/chr_profile1.bmp", NULL, NULL);
	textureMgr_loadTexture(g_texMgr, &m_p2BkTexID,
		"data/scene/select/character/chr_profile2.bmp", NULL, NULL);

	return This;
}

int __fastcall CBattleWatch_OnRender(void *This)
{
	int &m_p1TexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x00);
	int &m_p2TexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x04);
	int &m_p1BkTexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x08);
	int &m_p2BkTexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x0c);

	// super
	int ret = CBattleWatch_Render(This);

	// {CDesignACSpriteg΂񂾂
	if(CRenderer_Begin(g_renderer)) {
		DrawUnit(s_p1Unit, m_p1BkTexID, m_p1TexID);
		DrawUnit(s_p2Unit, m_p2BkTexID, m_p2TexID);
		CRenderer_End(g_renderer);
	}

	return ret;
}

void * __fastcall CBattleWatch_OnDestruct(void *This, int, int dyn)
{
	int &m_p1TexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x00);
	int &m_p2TexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x04);
	int &m_p1BkTexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x08);
	int &m_p2BkTexID = *(int *)((char *)This + s_origCBattleWatch_Size + 0x0c);

	// eNX`j
	textureMgr_remove(g_texMgr,m_p1TexID);
	textureMgr_remove(g_texMgr,m_p2TexID);
	textureMgr_remove(g_texMgr,m_p1BkTexID);
	textureMgr_remove(g_texMgr,m_p2BkTexID);

	return CBattleWatch_Destruct(This, dyn);
}

void LoadUnitSettings(DNameUnit &unit, LPCSTR profilePath, LPCSTR sectionName, int defaultX, int defaultY)
{
	::GetPrivateProfileString(sectionName, "Font.Face", 
		(char *)0x69F154, unit.fontDesc.FaceName, _countof(unit.fontDesc.FaceName), profilePath);

	unit.fontDesc.res_1CC = ::GetPrivateProfileInt(sectionName, "Font.Color1.R", 255, profilePath);
	unit.fontDesc.res_1CB = ::GetPrivateProfileInt(sectionName, "Font.Color1.G", 255, profilePath);
	unit.fontDesc.res_1CA = ::GetPrivateProfileInt(sectionName, "Font.Color1.B", 255, profilePath);

	unit.fontDesc.res_1C9 = ::GetPrivateProfileInt(sectionName, "Font.Color2.R", 255, profilePath);
	unit.fontDesc.res_1C8 = ::GetPrivateProfileInt(sectionName, "Font.Color2.G", 255, profilePath);
	unit.fontDesc.res_1C7 = ::GetPrivateProfileInt(sectionName, "Font.Color2.B", 255, profilePath);

	unit.fontDesc.res_1C4 = ::GetPrivateProfileInt(sectionName, "Font.Height", 14, profilePath);
	unit.fontDesc.res_1C0 = ::GetPrivateProfileInt(sectionName, "Font.Bold", 0, profilePath) ? FW_BOLD : FW_NORMAL;
	unit.fontDesc.res_1BC = ::GetPrivateProfileInt(sectionName, "Font.Italic", 0, profilePath) ? 1 : 0;

	unit.fontDesc.res_1BB = 1;      // y offset
	unit.fontDesc.res_1B8 = 100000; // ?
	unit.fontDesc.res_1AC = 0;		// char gap
	unit.fontDesc.res_1A8 = 2;      // ?

	unit.position.x = ::GetPrivateProfileInt(sectionName, "Position.X", defaultX, profilePath);
	unit.position.y = ::GetPrivateProfileInt(sectionName, "Position.Y", defaultY, profilePath);

	unit.backVisible = ::GetPrivateProfileInt(sectionName, "Back.Visible", 1, profilePath) != 0;
}

void LoadSettings(LPCSTR profilePath)
{
	LoadUnitSettings(s_p1Unit, profilePath, "1P", 0, 0);
	LoadUnitSettings(s_p2Unit, profilePath, "2P", 424, 0);
}

BOOL Hook(HMODULE hModule)
{
	char profilePath[1024 + MAX_PATH];

	GetModuleFileName(hModule, profilePath, 1024);
	PathRemoveFileSpec(profilePath);
	PathAppend(profilePath, "swrdname.ini");
	LoadSettings(profilePath);

	// 
	DWORD old;
	::VirtualProtect((PVOID)0x401000, 0x29D000, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCBattleWatch_Size = *(BYTE *)0x41DBFE;
	*(BYTE *)0x41DBFE += 0x10;
	s_origCBattleWatch_OnCreate = *(DWORD*)0x41DC1A + (0x41DC19 + 5);
	*(DWORD*)0x41DC1A = dangerous_cast<DWORD>(CBattleWatch_OnCreate) - (0x41DC19 + 5);
	::VirtualProtect((PVOID)0x401000, 0x29D000, old, &old);

	::VirtualProtect((PVOID)0x69E000, 0x23000, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCBattleWatch_OnDestruct = *(DWORD*)0x69E54C;
	*(DWORD*)0x69E54C = dangerous_cast<DWORD>(CBattleWatch_OnDestruct);
	s_origCBattleWatch_OnRender   = *(DWORD*)0x69E554;
	*(DWORD*)0x69E554 = dangerous_cast<DWORD>(CBattleWatch_OnRender);
	::VirtualProtect((PVOID)0x69E000, 0x23000, old, &old);

	::FlushInstructionCache(GetCurrentProcess(), NULL, 0);
	return TRUE;
}

extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	return (fdwReason == DLL_PROCESS_ATTACH) ? Hook(hModule) : TRUE;
}
